<script setup>
import {ref,reactive, onMounted} from "vue";
import { useThemeStore } from "../../stores/theme";
import { useToastStore } from "../../stores/toast";
import { useUserStore } from "../../stores/user";
import AppimmoService from "../../services/appimmo.service";
import Toast from './Toast.vue'

const appimmoService = AppimmoService
const toastStore = useToastStore()
const themeStore = useThemeStore()
const userStore = useUserStore()

const user = ref(null)

const getUserInfos = async () => {
  // const response = ref(await appimmoService.update(currentType.value, 'types/' + currentType.value.id))

  const response = ref(await appimmoService.get('user/' + userStore.user.id))
  user.value = response.value.data
}

const update = async () => {
  const response = ref(await appimmoService.update(user.value, 'user/' + user.value.id))
}


onMounted(() => {
  getUserInfos()
})

</script>

<template>

  <Toast/>
<!--{{ user }}-->
  <div class="p-4 m-4 rounded-lg">
    <h1 v-if="user === null" class="text-white text-center text-xl">Profil</h1>
    <h1 v-else class="text-white text-center text-xl">Profil de {{ user.username }}</h1>
    <form @submit.prevent="update">
      <div>
        <label for="name-toggle" class="inline-flex relative items-center cursor-pointer">
          <input v-if="user === null" type="checkbox" value="" id="name-toggle" class="sr-only peer">
          <input v-else v-model="user.show_name" type="checkbox" :false-value="0" :true-value="1" id="name-toggle" class="sr-only peer">
          <div class="w-11 h-6 bg-gray-200 peer-focus:outline-none peer-focus:ring-4 peer-focus:ring-blue-300 dark:peer-focus:ring-blue-800 rounded-full peer dark:bg-gray-700 peer-checked:after:translate-x-full peer-checked:after:border-white after:content-[''] after:absolute after:top-[2px] after:left-[2px] after:bg-white after:border-gray-300 after:border after:rounded-full after:h-5 after:w-5 after:transition-all dark:border-gray-600 peer-checked:bg-blue-600"></div>
          <span class="ml-3 text-sm font-medium text-gray-900 dark:text-gray-300"></span>
        </label>
        <label for="firsname" class="block mb-2 text-sm font-medium text-gray-900 dark:text-gray-300">Prénom</label>
        <input v-if="user === null" type="text" id="firsname" class="block w-full p-2 text-gray-900 border border-gray-300 rounded-lg bg-gray-50 sm:text-xs focus:ring-blue-500 focus:border-blue-500 dark:bg-gray-700 dark:border-gray-600 dark:placeholder-gray-400 dark:text-white dark:focus:ring-blue-500 dark:focus:border-blue-500">
        <input v-else v-model="user.firstname" type="text" id="firsname" class="block w-full p-2 text-gray-900 border border-gray-300 rounded-lg bg-gray-50 sm:text-xs focus:ring-blue-500 focus:border-blue-500 dark:bg-gray-700 dark:border-gray-600 dark:placeholder-gray-400 dark:text-white dark:focus:ring-blue-500 dark:focus:border-blue-500">
      </div>
      <div>
        <label for="lastname" class="block mb-2 text-sm font-medium text-gray-900 dark:text-gray-300">Nom</label>
        <input v-if="user === null" type="text" id="lastname" class="block w-full p-2 text-gray-900 border border-gray-300 rounded-lg bg-gray-50 sm:text-xs focus:ring-blue-500 focus:border-blue-500 dark:bg-gray-700 dark:border-gray-600 dark:placeholder-gray-400 dark:text-white dark:focus:ring-blue-500 dark:focus:border-blue-500">
        <input v-else v-model="user.lastname" type="text" id="lastname" class="block w-full p-2 text-gray-900 border border-gray-300 rounded-lg bg-gray-50 sm:text-xs focus:ring-blue-500 focus:border-blue-500 dark:bg-gray-700 dark:border-gray-600 dark:placeholder-gray-400 dark:text-white dark:focus:ring-blue-500 dark:focus:border-blue-500">
      </div>
      <div class="mt-3">
        <label for="email-toggle" class="inline-flex relative items-center cursor-pointer">
          <input v-if="user === null" type="checkbox" value="" id="email-toggle" class="sr-only peer">
          <input v-else v-model="user.show_email" type="checkbox" :false-value="0" :true-value="1" id="email-toggle" class="sr-only peer">
          <div class="w-11 h-6 bg-gray-200 peer-focus:outline-none peer-focus:ring-4 peer-focus:ring-blue-300 dark:peer-focus:ring-blue-800 rounded-full peer dark:bg-gray-700 peer-checked:after:translate-x-full peer-checked:after:border-white after:content-[''] after:absolute after:top-[2px] after:left-[2px] after:bg-white after:border-gray-300 after:border after:rounded-full after:h-5 after:w-5 after:transition-all dark:border-gray-600 peer-checked:bg-blue-600"></div>
          <span class="ml-3 text-sm font-medium text-gray-900 dark:text-gray-300"></span>
        </label>
        <label for="email" class="block mb-2 text-sm font-medium text-gray-900 dark:text-gray-300">Adresse mail</label>
        <input v-if="user === null" type="email" id="email" class="block w-full p-2 text-gray-900 border border-gray-300 rounded-lg bg-gray-50 sm:text-xs focus:ring-blue-500 focus:border-blue-500 dark:bg-gray-700 dark:border-gray-600 dark:placeholder-gray-400 dark:text-white dark:focus:ring-blue-500 dark:focus:border-blue-500">
        <input v-else v-model="user.email" type="email" id="email" class="block w-full p-2 text-gray-900 border border-gray-300 rounded-lg bg-gray-50 sm:text-xs focus:ring-blue-500 focus:border-blue-500 dark:bg-gray-700 dark:border-gray-600 dark:placeholder-gray-400 dark:text-white dark:focus:ring-blue-500 dark:focus:border-blue-500">
      </div>
      <div class="mt-3">
        <label for="phone-toggle" class="inline-flex relative items-center cursor-pointer">
          <input v-if="user === null"  type="checkbox" id="phone-toggle" class="sr-only peer">
          <input v-else v-model="user.show_phone" :false-value="0" :true-value="1" type="checkbox" id="phone-toggle" class="sr-only peer">
          <div class="w-11 h-6 bg-gray-200 peer-focus:outline-none peer-focus:ring-4 peer-focus:ring-blue-300 dark:peer-focus:ring-blue-800 rounded-full peer dark:bg-gray-700 peer-checked:after:translate-x-full peer-checked:after:border-white after:content-[''] after:absolute after:top-[2px] after:left-[2px] after:bg-white after:border-gray-300 after:border after:rounded-full after:h-5 after:w-5 after:transition-all dark:border-gray-600 peer-checked:bg-blue-600"></div>
          <span class="ml-3 text-sm font-medium text-gray-900 dark:text-gray-300"></span>
        </label>
        <label for="phone" class="block mb-2 text-sm font-medium text-gray-900 dark:text-gray-300">Numéro de téléphone</label>
        <input v-if="user === null" type="tel" id="phone" class="block w-full p-2 text-gray-900 border border-gray-300 rounded-lg bg-gray-50 sm:text-xs focus:ring-blue-500 focus:border-blue-500 dark:bg-gray-700 dark:border-gray-600 dark:placeholder-gray-400 dark:text-white dark:focus:ring-blue-500 dark:focus:border-blue-500">
        <input v-else v-model="user.phone" type="tel" id="phone" class="block w-full p-2 text-gray-900 border border-gray-300 rounded-lg bg-gray-50 sm:text-xs focus:ring-blue-500 focus:border-blue-500 dark:bg-gray-700 dark:border-gray-600 dark:placeholder-gray-400 dark:text-white dark:focus:ring-blue-500 dark:focus:border-blue-500">
      </div>
      <button type="submit" class="mt-3 text-white bg-blue-700 hover:bg-blue-800 focus:ring-4 focus:outline-none focus:ring-blue-300 font-medium rounded-lg text-sm w-full sm:w-auto px-5 py-2.5 text-center dark:bg-blue-600 dark:hover:bg-blue-700 dark:focus:ring-blue-800">Submit</button>
    </form>
  </div>
</template>